Subject: Re: bug#21730: 25.0.50; Random errors in redisplay--pre-redisplay-functions

From: Sergio Durigan Junior <[email-masked]>
Date: Tue, 25 Jul 2017 19:15:48 -0400

On Tuesday, July 25 2017, Eli Zaretskii wrote:

>> From: Sergio Durigan Junior <[email-masked]>
>> Cc: Philipp Stephani <[email-masked]>,  [email-masked],  [email-masked]
>> Date: Mon, 24 Jul 2017 22:06:56 -0400
>> 
>>   Debugger entered--Lisp error: (args-out-of-range 0)
>>     get-char-property(0 cursor-sensor-functions)
>>     cursor-sensor--detect(#<window 5650 on *Group*>)
>>                           ^^^^^^^^^^^^^^^^^^^^^^^^^
>>     run-hook-with-args(cursor-sensor--detect #<window 5650 on *Group*>)
>>     redisplay--pre-redisplay-functions(t)
>>     apply(redisplay--pre-redisplay-functions t)
>>     [ lots of other functions not interesting for us ]
>> 
>> I took the liberty to mark the interesting part above, which is the
>> argument to cursor-sensor--detect.  As you can notice, it's working on
>> the *Group* window, from Gnus.  Now, the interesting part that I noticed
>> and was able to verify is that this only happens when (a) I am not
>> working in that buffer, (b) the point is at (point-min) at that buffer,
>> but (c) the point is not (point-min) at the buffer I'm currently in.  In
>> this case, Emacs does some wrong calculations with point and ends up
>> with the value of 0, which makes sense if you consider that
>> (window-point) of that window is 1, but (bobp) is not t (because, as I
>> explained, I'm working in another buffer, and the value of point there
>> is not 1).
>> 
>> With all that said, I came to the conclusion that Phillip's rationale
>> makes sense and therefore his patch seems to be the best shot we have at
>> fixing this annoying bug.
>
> Thanks for following up.
>
> Phillip's hypothesis assumes that there's another function in
> pre-redisplay-function, which is called before cursor-sensor--detect
> and switches to another buffer, leaving us there.  Do you indeed have
> other functions on that list?  If so, what are they?

You know, that's a good question.

After looking into what I have here, I don't see any other function
being called before pre-redisplay-functions.  Everything seems fine and
I see the call to with-current-buffer before calling run-hook-with-args,
which means that, unless there is a bug somewhere, I don't see how the
buffer could have changed.

> I'm asking because I'd like to be sure we are on the right track with
> the root cause.

Sure thing.  Well, if you ask me, I'm convinced that what I explained in
my last message is what happens, but I still don't know *why* it
happens.  I'll see if I manage to investigate this a bit more.

Thanks,

-- 
Sergio
GPG key ID: 237A 54B1 0287 28BF 00EF  31F4 D0EB 7628 65FC 5E36
Please send encrypted e-mail if possible
http://sergiodj.net/